######################################################################
# Project: Estimation and Inference for Generalized Geoadditive Models
# Estimation for negative binomial in the HorseShoe domain
# Author: Shan Yu, Li Wang and GuanNan Wang
# Date: 09/09/2018
######################################################################
# QR decomposition of transpose(H)
qrH <- function(H){
  qrout=qr(t(H),tol=1e-10)
  QH=qr.Q(qrout,complete=TRUE)
  RH=qr.R(qrout,complete=TRUE)
  r1=qrout$rank
  if(r1>0 & r1<ncol(QH)){
    Q2=QH[,-(1:r1)]
  }else{
    Q2=c()
  }
  return(Q2)
}
